define(["require", "exports", 'react', 'react-dom', 'react-addons-test-utils', './Image', './Image.Props'], function (require, exports, React, ReactDOM, ReactTestUtils, Image_1, Image_Props_1) {
    "use strict";
    var expect = chai.expect;
    describe('Image', function () {
        it('renders an image', function (done) {
            ReactTestUtils.renderIntoDocument(React.createElement(Image_1.Image, {src: 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7', onLoad: function () {
                done();
            }}));
        });
        it('can render a covered square image in landscape', function (done) {
            var component = ReactTestUtils.renderIntoDocument(React.createElement(Image_1.Image, {src: 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7', width: 3, height: 1, imageFit: Image_Props_1.ImageFit.cover, onLoad: function () {
                var renderedDOM = ReactDOM.findDOMNode(component);
                var image = renderedDOM.querySelector('.ms-Image-image');
                try {
                    expect(image.className).to.contain('ms-Image-image--portrait');
                }
                catch (e) {
                    done(e);
                }
                done();
            }}));
        });
        it('can render a covered square image in portrait', function (done) {
            var component = ReactTestUtils.renderIntoDocument(React.createElement(Image_1.Image, {src: 'data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7', width: 1, height: 3, imageFit: Image_Props_1.ImageFit.cover, onLoad: function () {
                var renderedDOM = ReactDOM.findDOMNode(component);
                var image = renderedDOM.querySelector('.ms-Image-image');
                try {
                    expect(image.className).to.contain('ms-Image-image--landscape');
                }
                catch (e) {
                    done(e);
                }
                done();
            }}));
        });
    });
});

//# sourceMappingURL=Image.test.js.map
