define(["require", "exports", 'react', 'react-dom', 'react-addons-test-utils', './index'], function (require, exports, React, ReactDOM, ReactTestUtils, index_1) {
    "use strict";
    var expect = chai.expect;
    describe('TeachingBubble', function () {
        // <Layer> components will lead ReactDOM.findDOMNode(test_component) return null, so the test is based on the teaching bubble content.
        it('renders a label', function () {
            var component = ReactTestUtils.renderIntoDocument(React.createElement(index_1.TeachingBubbleContent, {headline: 'Title'}));
            var renderedDOM = ReactDOM.findDOMNode(component);
            var titleElement = renderedDOM.querySelector('.ms-TeachingBubble-headline');
            expect(titleElement.textContent).to.equal('Title');
        });
    });
});

//# sourceMappingURL=TeachingBubble.test.js.map
